/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;


public class AlarmInitReceiver extends BroadcastReceiver {

private static final String [] PROJECTION = new String [] {     // 声明一个私有静态变量PROJECTION，它是一个字符串数组，其中包含NoteColumns.ID和NoteColumns.ALERTED_DATE两个字符串
        NoteColumns.ID,
        NoteColumns.ALERTED_DATE
    };

    private static final int COLUMN_ID                = 0;
    private static final int COLUMN_ALERTED_DATE      = 1;

    @Override
    public void onReceive(Context context, Intent intent) {
        long currentDate = System.currentTimeMillis();      //获取当前时间
        Cursor c = context.getContentResolver().query(Notes.CONTENT_NOTE_URI,       //查询数据库中alerted_date大于当前时间，type为note的记录
                PROJECTION,
                NoteColumns.ALERTED_DATE + ">? AND " + NoteColumns.TYPE + "=" + Notes.TYPE_NOTE,
                new String[] { String.valueOf(currentDate) },
                null);

        if (c != null) {
            if (c.moveToFirst()) {
                do {
                    long alertDate = c.getLong(COLUMN_ALERTED_DATE);    //获取alerted_date
                    Intent sender = new Intent(context, AlarmReceiver.class);    //创建一个Intent，用于传递数据
                    sender.setData(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, c.getLong(COLUMN_ID)));    //将id传递给AlarmReceiver
                    PendingIntent pendingIntent = PendingIntent.getBroadcast(context, 0, sender, 0);    //创建一个PendingIntent，用于传递Intent
                    AlarmManager alermManager = (AlarmManager) context    //获取AlarmManager实例
                            .getSystemService(Context.ALARM_SERVICE);
                    alermManager.set(AlarmManager.RTC_WAKEUP, alertDate, pendingIntent);    //设置定时器，在alerted_date时间点，发送pendingIntent
                } while (c.moveToNext());
            }
            c.close();
        }
    }
}